package org.orangecloud00.ptmbukkit.generator;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import net.minecraft.server.Block;
import net.minecraft.server.BlockSand;
import net.minecraft.server.Chunk;
import net.minecraft.server.ChunkPosition;
import net.minecraft.server.EnumCreatureType;
import net.minecraft.server.IChunkProvider;
import net.minecraft.server.IProgressUpdate;
import net.minecraft.server.Material;
import net.minecraft.server.World;
import net.minecraft.server.WorldGenLakes;
import net.minecraft.server.WorldGenLiquids;

import org.bukkit.craftbukkit.CraftWorld;
import org.bukkit.generator.BlockPopulator;
import org.bukkit.generator.ChunkGenerator;
import org.orangecloud00.ptmbukkit.WorldConfig;
import org.orangecloud00.ptmbukkit.mc173.BiomeBase;
import org.orangecloud00.ptmbukkit.mc173.MapGenBase;
import org.orangecloud00.ptmbukkit.mc173.MapGenCaves;
import org.orangecloud00.ptmbukkit.mc173.NoiseGeneratorOctaves;
import org.orangecloud00.ptmbukkit.mc173.WorldChunkManager;
import org.orangecloud00.ptmbukkit.mc173.WorldGenCactus;
import org.orangecloud00.ptmbukkit.mc173.WorldGenClay;
import org.orangecloud00.ptmbukkit.mc173.WorldGenDeadBush;
import org.orangecloud00.ptmbukkit.mc173.WorldGenDungeons;
import org.orangecloud00.ptmbukkit.mc173.WorldGenFlowers;
import org.orangecloud00.ptmbukkit.mc173.WorldGenGrass;
import org.orangecloud00.ptmbukkit.mc173.WorldGenMinable;
import org.orangecloud00.ptmbukkit.mc173.WorldGenPumpkin;
import org.orangecloud00.ptmbukkit.mc173.WorldGenReed;
import org.orangecloud00.ptmbukkit.mc173.WorldGenerator;

public class ChunkProviderGenerate extends ChunkGenerator implements IChunkProvider
{
	private Random j;
	private NoiseGeneratorOctaves k;
	private NoiseGeneratorOctaves l;
	private NoiseGeneratorOctaves m;
	private NoiseGeneratorOctaves n;
	private NoiseGeneratorOctaves o;
	public NoiseGeneratorOctaves a;
	public NoiseGeneratorOctaves b;
	public NoiseGeneratorOctaves c;
	private World p;
	private WorldChunkManager wcm;
	private double[] q;
	private double[] r = new double[256];
	private double[] s = new double[256];
	private double[] t = new double[256];

	private MapGenBase u = new MapGenCaves();
	private BiomeBase[] v;
	private double[] d;
	private double[] e;
	private double[] f;
	private double[] g;
	private double[] h;
	private double[] w;

	private WorldConfig worldSettings;

	private ArrayList<BlockPopulator> populatorList;

	public void Init(World paramWorld, WorldChunkManager wcm, long paramLong)
	{
		System.out.println("initing chunk provider");

		this.p = paramWorld;
		this.wcm = wcm;

		this.j = new Random(paramLong);
		this.k = new NoiseGeneratorOctaves(this.j, 16);
		this.l = new NoiseGeneratorOctaves(this.j, 16);
		this.m = new NoiseGeneratorOctaves(this.j, 8);
		this.n = new NoiseGeneratorOctaves(this.j, 4);
		this.o = new NoiseGeneratorOctaves(this.j, 4);

		this.a = new NoiseGeneratorOctaves(this.j, 10);
		this.b = new NoiseGeneratorOctaves(this.j, 16);

		this.c = new NoiseGeneratorOctaves(this.j, 8);
	}

	public ChunkProviderGenerate(WorldConfig worldSettings)
	{
		this.worldSettings = worldSettings;
		this.worldSettings.ChunkProvider = this;
		populatorList = new ArrayList<BlockPopulator>();
		populatorList.add(new ObjectSpawner(this.worldSettings, this));
	}

	@Override
	public byte[] generate(org.bukkit.World world, Random random, int x, int z)
	{
		return getOrCreateChunk(x, z).b;
	}

	private void createChunkImpl(int paramInt1, int paramInt2, byte[] paramArrayOfByte,
			BiomeBase[] paramArrayOfBiomeBase, double[] paramArrayOfDouble)
	{
		int i1 = 4;
		int i2 = 64;

		int i3 = i1 + 1;
		int i4 = 17;
		int i5 = i1 + 1;
		this.q = selectBiome(this.q, paramInt1 * i1, 0, paramInt2 * i1, i3, i4, i5);

		for (int i6 = 0; i6 < i1; i6++)
			for (int i7 = 0; i7 < i1; i7++)
				for (int i8 = 0; i8 < 16; i8++)
				{
					double d1 = 0.125D;
					double d2 = this.q[(((i6 + 0) * i5 + (i7 + 0)) * i4 + (i8 + 0))];
					double d3 = this.q[(((i6 + 0) * i5 + (i7 + 1)) * i4 + (i8 + 0))];
					double d4 = this.q[(((i6 + 1) * i5 + (i7 + 0)) * i4 + (i8 + 0))];
					double d5 = this.q[(((i6 + 1) * i5 + (i7 + 1)) * i4 + (i8 + 0))];

					double d6 = (this.q[(((i6 + 0) * i5 + (i7 + 0)) * i4 + (i8 + 1))] - d2) * d1;
					double d7 = (this.q[(((i6 + 0) * i5 + (i7 + 1)) * i4 + (i8 + 1))] - d3) * d1;
					double d8 = (this.q[(((i6 + 1) * i5 + (i7 + 0)) * i4 + (i8 + 1))] - d4) * d1;
					double d9 = (this.q[(((i6 + 1) * i5 + (i7 + 1)) * i4 + (i8 + 1))] - d5) * d1;

					for (int i9 = 0; i9 < 8; i9++)
					{
						double d10 = 0.25D;

						double d11 = d2;
						double d12 = d3;
						double d13 = (d4 - d2) * d10;
						double d14 = (d5 - d3) * d10;

						for (int i10 = 0; i10 < 4; i10++)
						{
							int i11 = i10 + i6 * 4 << 11 | 0 + i7 * 4 << 7 | i8 * 8 + i9;
							int i12 = 128;
							double d15 = 0.25D;

							double d16 = d11;
							double d17 = (d12 - d11) * d15;
							for (int i13 = 0; i13 < 4; i13++)
							{
								double d18 = paramArrayOfDouble[((i6 * 4 + i10) * 16 + (i7 * 4 + i13))];
								int i14 = 0;
								if (i8 * 8 + i9 < i2)
								{
									if ((d18 < 0.5D) && (i8 * 8 + i9 >= i2 - 1))
										i14 = Block.ICE.id;
									else
									{
										i14 = Block.STATIONARY_WATER.id;
									}
								}
								if (d16 > 0.0D)
								{
									i14 = Block.STONE.id;
								}

								paramArrayOfByte[i11] = (byte) i14;
								i11 += i12;
								d16 += d17;
							}
							d11 += d13;
							d12 += d14;
						}

						d2 += d6;
						d3 += d7;
						d4 += d8;
						d5 += d9;
					}
				}
	}

	private void createChunkImpl(int paramInt1, int paramInt2, byte[] paramArrayOfByte,
			BiomeBase[] paramArrayOfBiomeBase)
	{
		int i1 = 64;

		double d1 = 0.03125D;
		this.r = this.n.generateOctavesNoise(this.r, paramInt1 * 16, paramInt2 * 16, 0.0D, 16, 16, 1, d1, d1, 1.0D);
		this.s = this.n.generateOctavesNoise(this.s, paramInt1 * 16, 109.0134D, paramInt2 * 16, 16, 1, 16, d1, 1.0D, d1);
		this.t = this.o.generateOctavesNoise(this.t, paramInt1 * 16, paramInt2 * 16, 0.0D, 16, 16, 1, d1 * 2.0D, d1 * 2.0D, d1 * 2.0D);

		for (int i2 = 0; i2 < 16; i2++)
			for (int i3 = 0; i3 < 16; i3++)
			{
				BiomeBase localBiomeBase = paramArrayOfBiomeBase[(i2 + i3 * 16)];
				int i4 = this.r[(i2 + i3 * 16)] + this.j.nextDouble() * 0.2D > 0.0D ? 1 : 0;
				int i5 = this.s[(i2 + i3 * 16)] + this.j.nextDouble() * 0.2D > 3.0D ? 1 : 0;
				int i6 = (int) (this.t[(i2 + i3 * 16)] / 3.0D + 3.0D + this.j.nextDouble() * 0.25D);

				int i7 = -1;

				byte i8 = localBiomeBase.p;
				byte i9 = localBiomeBase.q;

				for (int i10 = 127; i10 >= 0; i10--)
				{
					int i11 = (i3 * 16 + i2) * 128 + i10;

					if (i10 <= 0 + this.j.nextInt(5))
					{
						paramArrayOfByte[i11] = (byte) Block.BEDROCK.id;
					}
					else
					{
						int i12 = paramArrayOfByte[i11];

						if (i12 == 0)
							i7 = -1;
						else if (i12 == Block.STONE.id)
							if (i7 == -1)
							{
								if (i6 <= 0)
								{
									i8 = 0;
									i9 = (byte) Block.STONE.id;
								}
								else if ((i10 >= i1 - 4) && (i10 <= i1 + 1))
								{
									i8 = localBiomeBase.p;
									i9 = localBiomeBase.q;
									if (i5 != 0)
										i8 = 0;
									if (i5 != 0)
										i9 = (byte) Block.GRAVEL.id;
									if (i4 != 0)
										i8 = (byte) Block.SAND.id;
									if (i4 != 0)
										i9 = (byte) Block.SAND.id;
								}

								if ((i10 < i1) && (i8 == 0))
									i8 = (byte) Block.STATIONARY_WATER.id;

								i7 = i6;
								if (i10 >= i1 - 1)
									paramArrayOfByte[i11] = i8;
								else
									paramArrayOfByte[i11] = i9;
							}
							else if (i7 > 0)
							{
								i7--;
								paramArrayOfByte[i11] = i9;

								if ((i7 == 0) && (i9 == Block.SAND.id))
								{
									i7 = this.j.nextInt(4);
									i9 = (byte) Block.SANDSTONE.id;
								}
							}
					}
				}
			}
	}

	@Override
	public Chunk getChunkAt(int paramInt1, int paramInt2)
	{
		return getOrCreateChunk(paramInt1, paramInt2);
	}

	@Override
	public Chunk getOrCreateChunk(int paramInt1, int paramInt2)
	{
		this.j.setSeed(paramInt1 * 341873128712L + paramInt2 * 132897987541L);

		byte[] arrayOfByte = new byte[32768];
		Chunk localChunk = new Chunk(this.p, arrayOfByte, paramInt1, paramInt2);
		this.v = this.wcm.a(this.v, paramInt1 * 16, paramInt2 * 16, 16, 16);
		double[] arrayOfDouble = this.wcm.temperature;

		createChunkImpl(paramInt1, paramInt2, arrayOfByte, this.v, arrayOfDouble);
		createChunkImpl(paramInt1, paramInt2, arrayOfByte, this.v);

		this.u.generateTerrain(this, this.p, paramInt1, paramInt2, arrayOfByte);

		localChunk.initLighting();

		return localChunk;
	}

	private double[] selectBiome(double[] paramArrayOfDouble, int paramInt1, int paramInt2, int paramInt3,
			int paramInt4, int paramInt5, int paramInt6)
	{
		if (paramArrayOfDouble == null)
		{
			paramArrayOfDouble = new double[paramInt4 * paramInt5 * paramInt6];
		}

		double d1 = 684.41200000000003D;
		double d2 = 684.41200000000003D;

		double[] arrayOfDouble1 = this.wcm.temperature;
		double[] arrayOfDouble2 = this.wcm.rain;
		this.g = this.a.generateOctavesNoise(this.g, paramInt1, paramInt3, paramInt4, paramInt6, 1.121D, 1.121D, 0.5D);
		this.h = this.b.generateOctavesNoise(this.h, paramInt1, paramInt3, paramInt4, paramInt6, 200.0D, 200.0D, 0.5D);

		this.d = this.m.generateOctavesNoise(this.d, paramInt1, paramInt2, paramInt3, paramInt4, paramInt5, paramInt6, d1 / 80.0D,
				d2 / 160.0D, d1 / 80.0D);
		this.e = this.k.generateOctavesNoise(this.e, paramInt1, paramInt2, paramInt3, paramInt4, paramInt5, paramInt6, d1, d2, d1);
		this.f = this.l.generateOctavesNoise(this.f, paramInt1, paramInt2, paramInt3, paramInt4, paramInt5, paramInt6, d1, d2, d1);

		int i1 = 0;
		int i2 = 0;

		int i3 = 16 / paramInt4;
		for (int i4 = 0; i4 < paramInt4; i4++)
		{
			int i5 = i4 * i3 + i3 / 2;

			for (int i6 = 0; i6 < paramInt6; i6++)
			{
				int i7 = i6 * i3 + i3 / 2;
				double d3 = arrayOfDouble1[(i5 * 16 + i7)];
				double d4 = arrayOfDouble2[(i5 * 16 + i7)] * d3;
				double d5 = 1.0D - d4;
				d5 *= d5;
				d5 *= d5;
				d5 = 1.0D - d5;

				double d6 = (this.g[i2] + 256.0D) / 512.0D;
				d6 *= d5;
				if (d6 > 1.0D)
					d6 = 1.0D;

				double d7 = this.h[i2] / 8000.0D;
				if (d7 < 0.0D)
					d7 = -d7 * 0.3D;
				d7 = d7 * 3.0D - 2.0D;

				if (d7 < 0.0D)
				{
					d7 /= 2.0D;
					if (d7 < -1.0D)
						d7 = -1.0D;
					d7 /= 1.4D;
					d7 /= 2.0D;
					d6 = 0.0D;
				}
				else
				{
					if (d7 > 1.0D)
						d7 = 1.0D;
					d7 /= 8.0D;
				}

				if (d6 < 0.0D)
					d6 = 0.0D;
				d6 += 0.5D;
				d7 = d7 * paramInt5 / 16.0D;

				double d8 = paramInt5 / 2.0D + d7 * 4.0D;

				i2++;

				for (int i8 = 0; i8 < paramInt5; i8++)
				{
					double d9 = 0.0D;

					double d10 = (i8 - d8) * 12.0D / d6;

					if (d10 < 0.0D)
						d10 *= 4.0D;

					double d11 = this.e[i1] / 512.0D;
					double d12 = this.f[i1] / 512.0D;

					double d13 = (this.d[i1] / 10.0D + 1.0D) / 2.0D;
					if (d13 < 0.0D)
						d9 = d11;
					else if (d13 > 1.0D)
						d9 = d12;
					else
						d9 = d11 + (d12 - d11) * d13;
					d9 -= d10;

					if (i8 > paramInt5 - 4)
					{
						double d14 = (i8 - (paramInt5 - 4)) / 3.0F;
						d9 = d9 * (1.0D - d14) + -10.0D * d14;
					}

					paramArrayOfDouble[i1] = d9;
					i1++;
				}
			}
		}
		return paramArrayOfDouble;
	}

	@Override
	public boolean isChunkLoaded(int paramInt1, int paramInt2)
	{
		return true;
	}

	@Override
	public void getChunkAt(IChunkProvider paramIChunkProvider, int paramInt1, int paramInt2)
	{
		BlockSand.instaFall = true;
		int i1 = paramInt1 * 16;
		int i2 = paramInt2 * 16;

		BiomeBase localBiomeBase = this.wcm.getBiome(i1 + 16, i2 + 16);

		//System.out.println(localBiomeBase);
		
		this.j.setSeed(this.p.getSeed());
		long l1 = this.j.nextLong() / 2L * 2L + 1L;
		long l2 = this.j.nextLong() / 2L * 2L + 1L;
		this.j.setSeed(paramInt1 * l1 + paramInt2 * l2 ^ this.p.getSeed());
		double d1 = 0.25D;

		int i3;
		int i4;
		int i5;
		int i6;

		if (this.j.nextInt(4) == 0)
		{
			i3 = i1 + this.j.nextInt(16) + 8;
			i4 = this.j.nextInt(128);
			i5 = i2 + this.j.nextInt(16) + 8;
			new WorldGenLakes(Block.STATIONARY_WATER.id).a(this.p, this.j, i3, i4, i5);
		}

		if (this.j.nextInt(8) == 0)
		{
			i3 = i1 + this.j.nextInt(16) + 8;
			i4 = this.j.nextInt(this.j.nextInt(120) + 8);
			i5 = i2 + this.j.nextInt(16) + 8;
			if ((i4 < 64) || (this.j.nextInt(10) == 0))
				new WorldGenLakes(Block.STATIONARY_LAVA.id).a(this.p, this.j, i3, i4, i5);
		}

		for (i3 = 0; i3 < 8; i3++)
		{
			i4 = i1 + this.j.nextInt(16) + 8;
			i5 = this.j.nextInt(128);
			i6 = i2 + this.j.nextInt(16) + 8;
			new WorldGenDungeons().genObjects(this.p, this.j, i4, i5, i6);
		}

		for (i3 = 0; i3 < 10; i3++)
		{
			i4 = i1 + this.j.nextInt(16);
			i5 = this.j.nextInt(128);
			i6 = i2 + this.j.nextInt(16);
			new WorldGenClay(32).genObjects(this.p, this.j, i4, i5, i6);
		}

		for (i3 = 0; i3 < 20; i3++)
		{
			i4 = i1 + this.j.nextInt(16);
			i5 = this.j.nextInt(128);
			i6 = i2 + this.j.nextInt(16);
			new WorldGenMinable(Block.DIRT.id, 32).genObjects(this.p, this.j, i4, i5, i6);
		}

		for (i3 = 0; i3 < 10; i3++)
		{
			i4 = i1 + this.j.nextInt(16);
			i5 = this.j.nextInt(128);
			i6 = i2 + this.j.nextInt(16);
			new WorldGenMinable(Block.GRAVEL.id, 32).genObjects(this.p, this.j, i4, i5, i6);
		}

		for (i3 = 0; i3 < 20; i3++)
		{
			i4 = i1 + this.j.nextInt(16);
			i5 = this.j.nextInt(128);
			i6 = i2 + this.j.nextInt(16);
			new WorldGenMinable(Block.COAL_ORE.id, 16).genObjects(this.p, this.j, i4, i5, i6);
		}

		for (i3 = 0; i3 < 20; i3++)
		{
			i4 = i1 + this.j.nextInt(16);
			i5 = this.j.nextInt(64);
			i6 = i2 + this.j.nextInt(16);
			new WorldGenMinable(Block.IRON_ORE.id, 8).genObjects(this.p, this.j, i4, i5, i6);
		}

		for (i3 = 0; i3 < 2; i3++)
		{
			i4 = i1 + this.j.nextInt(16);
			i5 = this.j.nextInt(32);
			i6 = i2 + this.j.nextInt(16);
			new WorldGenMinable(Block.GOLD_ORE.id, 8).genObjects(this.p, this.j, i4, i5, i6);
		}

		for (i3 = 0; i3 < 8; i3++)
		{
			i4 = i1 + this.j.nextInt(16);
			i5 = this.j.nextInt(16);
			i6 = i2 + this.j.nextInt(16);
			new WorldGenMinable(Block.REDSTONE_ORE.id, 7).genObjects(this.p, this.j, i4, i5, i6);
		}

		for (i3 = 0; i3 < 1; i3++)
		{
			i4 = i1 + this.j.nextInt(16);
			i5 = this.j.nextInt(16);
			i6 = i2 + this.j.nextInt(16);
			new WorldGenMinable(Block.DIAMOND_ORE.id, 7).genObjects(this.p, this.j, i4, i5, i6);
		}

		for (i3 = 0; i3 < 1; i3++)
		{
			i4 = i1 + this.j.nextInt(16);
			i5 = this.j.nextInt(16) + this.j.nextInt(16);
			i6 = i2 + this.j.nextInt(16);
			new WorldGenMinable(Block.LAPIS_ORE.id, 6).genObjects(this.p, this.j, i4, i5, i6);
		}

		d1 = 0.5D;
		i3 = (int) ((this.c.generateOctavesNoise(i1 * d1, i2 * d1) / 8.0D + this.j.nextDouble() * 4.0D + 4.0D) / 3.0D);

		i4 = 0;
		if (this.j.nextInt(10) == 0)
			i4++;

		if (localBiomeBase == BiomeBase.FOREST)
			i4 += i3 + 5;
		if (localBiomeBase == BiomeBase.RAINFOREST)
			i4 += i3 + 5;
		if (localBiomeBase == BiomeBase.SEASONAL_FOREST)
			i4 += i3 + 2;
		if (localBiomeBase == BiomeBase.TAIGA)
			i4 += i3 + 5;

		if (localBiomeBase == BiomeBase.DESERT)
			i4 -= 20;
		if (localBiomeBase == BiomeBase.TUNDRA)
			i4 -= 20;
		if (localBiomeBase == BiomeBase.PLAINS)
			i4 -= 20;

		int i7;
		for (i5 = 0; i5 < i4; i5++)
		{
			i6 = i1 + this.j.nextInt(16) + 8;
			i7 = i2 + this.j.nextInt(16) + 8;
			WorldGenerator localWorldGenerator = localBiomeBase.formBiome(this.j);
			localWorldGenerator.initializeObjectGen(1.0D, 1.0D, 1.0D);
			localWorldGenerator.genObjects(this.p, this.j, i6, this.p.getHighestBlockYAt(i6, i7), i7);
		}

		i5 = 0;
		if (localBiomeBase == BiomeBase.FOREST)
			i5 = 2;
		if (localBiomeBase == BiomeBase.SEASONAL_FOREST)
			i5 = 4;
		if (localBiomeBase == BiomeBase.TAIGA)
			i5 = 2;
		if (localBiomeBase == BiomeBase.PLAINS)
			i5 = 3;
		int i8, i9;
		for (i6 = 0; i6 < i5; i6++)
		{
			i7 = i1 + this.j.nextInt(16) + 8;
			i8 = this.j.nextInt(128);
			i9 = i2 + this.j.nextInt(16) + 8;
			new WorldGenFlowers(Block.YELLOW_FLOWER.id).genObjects(this.p, this.j, i7, i8, i9);
		}

		i6 = 0;

		if (localBiomeBase == BiomeBase.FOREST)
			i6 = 2;
		if (localBiomeBase == BiomeBase.RAINFOREST)
			i6 = 10;
		if (localBiomeBase == BiomeBase.SEASONAL_FOREST)
			i6 = 2;
		if (localBiomeBase == BiomeBase.TAIGA)
			i6 = 1;
		if (localBiomeBase == BiomeBase.PLAINS)
			i6 = 10;
		int i10;
		int i11;
		for (i7 = 0; i7 < i6; i7++)
		{
			i8 = 1;

			if ((localBiomeBase == BiomeBase.RAINFOREST) && (this.j.nextInt(3) != 0))
				i8 = 2;

			i9 = i1 + this.j.nextInt(16) + 8;
			i10 = this.j.nextInt(128);
			i11 = i2 + this.j.nextInt(16) + 8;
			new WorldGenGrass(Block.LONG_GRASS.id, i8).genObjects(this.p, this.j, i9, i10, i11);
		}

		i6 = 0;
		if (localBiomeBase == BiomeBase.DESERT)
			i6 = 2;

		for (i7 = 0; i7 < i6; i7++)
		{
			i8 = i1 + this.j.nextInt(16) + 8;
			i9 = this.j.nextInt(128);
			i10 = i2 + this.j.nextInt(16) + 8;
			new WorldGenDeadBush(Block.DEAD_BUSH.id).genObjects(this.p, this.j, i8, i9, i10);
		}

		if (this.j.nextInt(2) == 0)
		{
			i7 = i1 + this.j.nextInt(16) + 8;
			i8 = this.j.nextInt(128);
			i9 = i2 + this.j.nextInt(16) + 8;
			new WorldGenFlowers(Block.RED_ROSE.id).genObjects(this.p, this.j, i7, i8, i9);
		}

		if (this.j.nextInt(4) == 0)
		{
			i7 = i1 + this.j.nextInt(16) + 8;
			i8 = this.j.nextInt(128);
			i9 = i2 + this.j.nextInt(16) + 8;
			new WorldGenFlowers(Block.BROWN_MUSHROOM.id).genObjects(this.p, this.j, i7, i8, i9);
		}

		if (this.j.nextInt(8) == 0)
		{
			i7 = i1 + this.j.nextInt(16) + 8;
			i8 = this.j.nextInt(128);
			i9 = i2 + this.j.nextInt(16) + 8;
			new WorldGenFlowers(Block.RED_MUSHROOM.id).genObjects(this.p, this.j, i7, i8, i9);
		}

		for (i7 = 0; i7 < 10; i7++)
		{
			i8 = i1 + this.j.nextInt(16) + 8;
			i9 = this.j.nextInt(128);
			i10 = i2 + this.j.nextInt(16) + 8;
			new WorldGenReed().genObjects(this.p, this.j, i8, i9, i10);
		}

		if (this.j.nextInt(32) == 0)
		{
			i7 = i1 + this.j.nextInt(16) + 8;
			i8 = this.j.nextInt(128);
			i9 = i2 + this.j.nextInt(16) + 8;
			new WorldGenPumpkin().genObjects(this.p, this.j, i7, i8, i9);
		}

		i7 = 0;
		if (localBiomeBase == BiomeBase.DESERT)
			i7 += 10;

		for (i8 = 0; i8 < i7; i8++)
		{
			i9 = i1 + this.j.nextInt(16) + 8;
			i10 = this.j.nextInt(128);
			i11 = i2 + this.j.nextInt(16) + 8;
			new WorldGenCactus().genObjects(this.p, this.j, i9, i10, i11);
		}

		for (i8 = 0; i8 < 50; i8++)
		{
			i9 = i1 + this.j.nextInt(16) + 8;
			i10 = this.j.nextInt(this.j.nextInt(120) + 8);
			i11 = i2 + this.j.nextInt(16) + 8;
			new WorldGenLiquids(Block.WATER.id).a(this.p, this.j, i9, i10, i11);
		}

		for (i8 = 0; i8 < 20; i8++)
		{
			i9 = i1 + this.j.nextInt(16) + 8;
			i10 = this.j.nextInt(this.j.nextInt(this.j.nextInt(112) + 8) + 8);
			i11 = i2 + this.j.nextInt(16) + 8;
			new WorldGenLiquids(Block.LAVA.id).a(this.p, this.j, i9, i10, i11);
		}

		this.w = this.wcm.addNoise(this.w, i1 + 8, i2 + 8, 16, 16);
		for (i8 = i1 + 8; i8 < i1 + 8 + 16; i8++)
		{
			for (i9 = i2 + 8; i9 < i2 + 8 + 16; i9++)
			{
				i10 = i8 - (i1 + 8);
				i11 = i9 - (i2 + 8);
				int i12 = this.p.e(i8, i9);
				double d2 = this.w[(i10 * 16 + i11)] - (i12 - 64) / 64.0D * 0.3D;
				if ((d2 >= 0.5D) || (i12 <= 0) || (i12 >= 128) || (!this.p.isEmpty(i8, i12, i9))
						|| (!this.p.getMaterial(i8, i12 - 1, i9).isSolid())
						|| (this.p.getMaterial(i8, i12 - 1, i9) == Material.ICE))
					continue;
				this.p.setTypeId(i8, i12, i9, Block.SNOW.id);
			}

		}

		BlockSand.instaFall = false;
	}

	@Override
	public boolean saveChunks(boolean paramBoolean, IProgressUpdate paramIProgressUpdate)
	{
		return true;
	}

	@Override
	public boolean unloadChunks()
	{
		return false;
	}

	@Override
	public boolean canSave()
	{
		return true;
	}

	@Override
	public List<BlockPopulator> getDefaultPopulators(org.bukkit.World world)
	{
		return populatorList;
	}

	@Override
	public boolean canSpawn(org.bukkit.World world, int x, int z)
	{
		this.worldSettings.plugin.WorldInit(world);

		int i = ((CraftWorld) world).getHandle().a(x, z);
		return i != 0 && Block.byId[i].material.isSolid();

	}

	@Override
	public ChunkPosition findNearestMapFeature(World arg0, String arg1,
			int arg2, int arg3, int arg4) {
		// TODO Auto-generated method stub
		return null;
	}

	@SuppressWarnings("rawtypes")
	@Override
	public List getMobsFor(EnumCreatureType arg0, int arg1, int arg2, int arg3) {
		// TODO Auto-generated method stub
		return null;
	}
}